9bfc59b6c87f2394a9fe67b22f007a84db79fc0a
[ric-plt/lib/rmr.git] / test / app_test / run_multi_test.ksh
1 #!/usr/bin/env ksh
2 # :vi ts=4 sw=4 noet :
3 #==================================================================================
4 #    Copyright (c) 2019 Nokia
5 #    Copyright (c) 2018-2019 AT&T Intellectual Property.
6 #
7 #   Licensed under the Apache License, Version 2.0 (the "License");
8 #   you may not use this file except in compliance with the License.
9 #   You may obtain a copy of the License at
10 #
11 #       http://www.apache.org/licenses/LICENSE-2.0
12 #
13 #   Unless required by applicable law or agreed to in writing, software
14 #   distributed under the License is distributed on an "AS IS" BASIS,
15 #   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
16 #   See the License for the specific language governing permissions and
17 #   limitations under the License.
18 #==================================================================================
19 #
20
21 # ---------------------------------------------------------------------------------
22 #       Mnemonic:       run_multi_test.ksh
23 #       Abstract:       This is a simple script to set up and run the basic send/receive
24 #                               processes for some library validation on top of nano/nng. This 
25 #                               particular tests starts several receivers and creates a route table
26 #                               which causes messages to be sent to all receivers in parallel
27 #                               (forcing message cloning internally in RMr).
28 #                               It should be possible to clone the repo, switch to this directory
29 #                               and execute  'ksh run -B'  which will build RMr, make the sender and
30 #                               recevier then  run the basic test.
31 #
32 #                               Example command line:
33 #                                       ksh ./run_multi_test.ksh                # default 10 messages at 1 msg/sec
34 #                                       ksh ./run_multi_test.ksh -N    # default but with nanomsg lib
35 #                                       ksh ./run_multi_test.ksh -d 100 -n 10000 # send 10k messages with 100ms delay between
36 #
37 #       Date:           24 April 2019
38 #       Author:         E. Scott Daniels
39 # ---------------------------------------------------------------------------------
40
41
42 # The sender and receivers are run asynch. Their exit statuses are captured in a
43 # file in order for the 'main' to pick them up easily.
44 #
45 function run_sender {
46         if (( $nano_sender ))
47         then
48                 ./sender_nano $nmsg $delay
49         else
50                 ./sender $nmsg $delay
51         fi
52         echo $? >/tmp/PID$$.src         # must communicate state back via file b/c asynch
53 }
54
55 # $1 is the instance so we can keep logs separate
56 function run_rcvr {
57         typeset port
58
59         port=$(( 4460 + ${1:-0} ))
60         export RMR_RTG_SVC=$(( 9990 + $1 ))
61         if (( $nano_receiver ))
62         then
63                 ./receiver_nano $nmsg $port
64         else
65                 ./receiver $nmsg $port
66         fi
67         echo $? >/tmp/PID$$.$1.rrc
68 }
69
70 #       Drop a contrived route table in such that the sender sends each message to n
71 #       receivers.
72 #
73 function set_rt {
74         typeset port=4460
75         typeset groups="localhost:4460"
76         for (( i=1; i < ${1:-3}; i++ ))
77         do
78                 groups="$groups;localhost:$((port+i))"
79         done
80
81         cat <<endKat >multi.rt
82                 newrt | start
83                 mse |0 | 0 | $groups
84                 mse |1 | 10 | $groups
85                 mse |2 | 20 | $groups
86                 rte |3 | $groups 
87                 rte |4 | $groups 
88                 rte |5 | $groups
89                 rte |6 | $groups
90                 rte |7 | $groups
91                 rte |8 | $groups
92                 rte |9 | $groups
93                 rte |10 | $groups
94                 rte |11 | $groups
95                 newrt | end
96 endKat
97
98 }
99
100 # ---------------------------------------------------------
101
102 if [[ ! -f local.rt ]]          # we need the real host name in the local.rt; build one from mask if not there
103 then
104         hn=$(hostname)
105         sed "s!%%hostname%%!$hn!" rt.mask >local.rt
106 fi
107
108 nmsg=10                                         # total number of messages to be exchanged (-n value changes)
109 delay=1000000                           # microsec sleep between msg 1,000,000 == 1s
110 nano_sender=0                           # start nano version if set (-N)
111 nano_receiver=0
112 wait=1
113 rebuild=0
114 verbose=0
115 nrcvrs=3                                        # this is sane, but -r allows it to be set up
116
117 while [[ $1 == -* ]]
118 do
119         case $1 in 
120                 -B)     rebuild=1;;
121                 -d)     delay=$2; shift;;
122                 -N)     nano_sender=1
123                         nano_receiver=1
124                         ;;
125                 -n)     nmsg=$2; shift;;
126                 -r)     nrcvrs=$2; shift;;
127                 -v)     verbose=1;;
128
129                 *)      echo "unrecognised option: $1"
130                         echo "usage: $0 [-B] [-d micor-sec-delay] [-N] [-n num-msgs]"
131                         echo "  -B forces a rebuild which will use .build"
132                         exit 1
133                         ;;
134         esac
135
136         shift
137 done
138
139 if (( verbose ))
140 then
141         echo "2" >.verbose
142         export RMR_VCTL_FILE=".verbose"
143 fi
144
145 if (( rebuild )) 
146 then
147         build_path=../../.build         # if we rebuild we can insist that it is in .build :)
148         set -e
149         ksh ./rebuild.ksh
150         set +e
151 else
152         build_path=${BUILD_PATH:-"../../.build"}        # we prefer .build at the root level, but allow user option
153
154         if [[ ! -d $build_path ]]
155         then
156                 echo "cannot find build in: $build_path"
157                 echo "either create, and then build RMr, or set BUILD_PATH as an evironment var before running this"
158                 exit 1
159         fi
160 fi
161
162 export LD_LIBRARY_PATH=$build_path:$build_path/lib
163 export LIBRARY_PATH=$LD_LIBRARY_PATH
164 export RMR_SEED_RT=./multi.rt
165
166 set_rt $nrcvrs                                          # set up the rt for n receivers
167
168 if [[ ! -f ./sender ]]
169 then
170         if ! make >/dev/null 2>&1
171         then
172                 echo "[FAIL] cannot find sender binary, and cannot make it.... humm?"
173                 exit 1
174         fi
175 fi
176
177 for (( i=0; i < nrcvrs; i++ ))          # start the receivers with an instance number
178 do
179         run_rcvr $i &
180 done
181
182 sleep 2                         # let receivers init so we don't shoot at an empty target
183 run_sender &
184
185 wait
186
187
188 for (( i=0; i < nrcvrs; i++ ))          # collect return codes
189 do
190         head -1 /tmp/PID$$.$i.rrc | read x
191         (( rrc += x ))
192 done
193
194 head -1 /tmp/PID$$.src | read src
195
196 if (( !! (src + rrc) ))
197 then
198         echo "[FAIL] sender rc=$src  receiver rc=$rrc"
199 else
200         echo "[PASS] sender rc=$src  receiver rc=$rrc"
201         rm -f multi.rt
202 fi
203
204 rm /tmp/PID$$.*
205 rm -f .verbose
206
207 exit $(( !! (src + rrc) ))
208